# Get hotel search results

Get all available hotels for the requested search parameters.

Endpoint: POST /v2/hotel/search
Version: v2
Security: Bearer

## Security:

  - `Bearer` (unknown)
    http bearer

## Request fields (application/json):

  - `searchParams` (object, required)
    The parameters required for searching hotels.

  - `searchParams.occupancyDates` (object, required)

  - `searchParams.occupancyDates.occupancy` (array, required)
    List of occupancy details including the number of adults and children.

  - `searchParams.occupancyDates.occupancy.numAdults` (integer, required)
    The number of adults staying in the room.
    Example: 1

  - `searchParams.occupancyDates.occupancy.numChildren` (integer)
    The number of children staying in the room.
    Example: 0

  - `searchParams.occupancyDates.occupancy.childAges` (array)
    Ages of the children. Required when numChildren is greater than 0.
    Example: [4,7]

  - `searchParams.occupancyDates.occupancy.numInfants` (integer)
    Number of infants staying in the room.
    Example: 0

  - `searchParams.occupancyDates.checkInDate` (object, required)
    Local date and time in ISO 8601 format.

  - `searchParams.occupancyDates.checkInDate.iso8601` (string, required)
    Example: 2017-07-21T17:32

  - `searchParams.searchBy` (object, required)
    Criteria used for searching hotels. The `searchType` field can contain one criteria per request.

  - `searchParams.searchBy.searchType` (string, required)
    Enum: "AIRPORT", "COORDINATES", "HOTEL_CODE", "HOTEL_CODES"

  - `searchParams.searchBy.airport` (string, required)
    IATA code of the airport. The search result will contain the list of hotels in close proximity to the specified airport.
    Example: LHR

  - `searchParams.searchBy.coordinates` (object, required)
    Latitude and Longitude for a Location

  - `searchParams.searchBy.coordinates.latitude` (number, required)
    Latitude of the Location
    Example: 77.1025

  - `searchParams.searchBy.coordinates.longitude` (number, required)
    Longitude of the Location
    Example: 28.7041

  - `searchParams.searchBy.hotelCode` (string, required)
    Unique code for a hotel. The search result will also contain other hotels in close proximity to the requested hotel code.
    Example: SPOTNANA:12345

  - `searchParams.searchBy.hotelCodes` (array, required)
    List of hotel codes to be included in the search result.

  - `filters` (object)
    Filters to refine the search result. Based on the user selected filters, the list of matching hotels will be displayed.

  - `filters.prepaidQualifier` (string)
    Prepaid qualifiers.
    Enum: "INCLUDE_PREPAID", "EXCLUDE_PREPAID", "PREPAID_ONLY"

  - `filters.priceRange` (object)
    SimpleMoney range containing minimum and maximum amount.

  - `filters.priceRange.min` (object)
    Money object containing just amount and currency code.

  - `filters.priceRange.min.amount` (number, required)
    Amount
    Example: 510

  - `filters.priceRange.min.currencyCode` (string, required)
    The 3-letter currency code defined in ISO 4217.
    Example: GBP

  - `filters.amenities` (array)
    List of preferred amenities to be included in the hotel search result.

  - `filters.chainCodes` (array)
    List of preferred hotel chain codes to be included in the search result.
A hotel chain is a company that owns or operates multiple hotels across different locations.
These hotel chains have a unique code which can be used here as an array.

  - `filters.brandCodes` (array)
    Sub-chain or brand codes. A hotel matches when its chain code is in this list.

  - `filters.radius` (object)
    Specifies the length or a distance.

  - `filters.radius.length` (number, required)
    Distance from search point.
    Example: 150

  - `filters.radius.unit` (string, required)
    Unit of measure being applied.
    Enum: "UNKNOWN_UNIT", "KM", "MILE", "CENTIMETER", "METER"

  - `filters.starRatings` (array)
    Indicates the star quality rating of a hotel. Filter search result using preferred star ratings.

  - `filters.nameQuery` (string)
    The name of the hotel to be included in the search query.

  - `filters.eligibleForLoyalty` (boolean)
    Include hotels that are eligible for loyalty points.
    Example: false

  - `filters.showUnavailable` (boolean)
    Include unavailable hotels.
    Example: false

  - `filters.payByPoints` (boolean)
    Include hotels that support payment by points.
    Example: false

  - `filters.modifiableOnly` (boolean)
    Include hotels that allow users to modify their booking.
    Example: false

  - `filters.rateTypes` (array)
    List of rate type identifiers to filter the search results.

  - `filters.propertyTypes` (array)
    Filter by property type such as a hotel, an apartment, bed and breakfast, and so on.

  - `filters.propertyTypes.type` (string, required)
    Enum: "ALL_SUITE", "ALL_INCLUSIVE_RESORT", "APARTMENT", "BED_AND_BREAKFAST", "CABIN_OR_BUNGALOW", "CAMPGROUND", "CHALET", "CONDOMINIUM", "CONFERENCE_CENTER", "CORPORATE_BUSINESS_TRANSIENT", "CRUISE", "EXTENDED_STAY", "GUEST_FARM", "GUEST_HOUSE_LIMITED_SERVICE", "HEALTH_SPA", "HOLIDAY_RESORT", "HOSTEL", "HOTEL", "INN", "LODGE", "MONASTERY", "MOTEL", "RANCH", "RESIDENTIAL_APARTMENT", "RESORT", "TENT", "VACATION_HOME", "VILLA", "WILDLIFE_RESERVE", "CASTLE", "GOLF", "PENSION", "SKI", "SPA", "BOATEL", "HISTORICAL", "RECREATIONAL_VEHICLE_PARK", "CHARM_HOTEL", "OTHER"

  - `filters.propertyTypes.description` (string)
    Description of the property type.

  - `filters.refundableOnly` (boolean)
    Include hotels that support refund of the booking.
    Example: false

  - `filters.preferredOnly` (boolean)
    Filter to show only preferred hotels.
    Example: false

  - `filters.virtualPaymentOnly` (boolean)
    Filter to show only hotels that accept virtual card payment.
    Example: false

  - `filters.specificHotelSearch` (boolean)
    When true on a hotel-code search, return only the requested hotel code or hotel codes.
Nearby hotels are not added. An airport or coordinate search with this flag set is
rejected. Distance on each hotel is measured from the first hotel code.
    Example: false

  - `sortOptions` (array)
    Sort options for the search results.

  - `sortOptions.sortBy` (string, required)
    Sorting criteria for the hotel search results.
    Enum: "PRICE", "DISTANCE", "SABRE_RATING", "POPULARITY"

  - `sortOptions.sortOrder` (string, required)
    The order in which the search results should be displayed.
    Enum: "ASCENDING", "DESCENDING"

  - `userId` (object, required)
    An identifier for the user involved in the hotel booking or search process.

  - `userId.userIdType` (string, required)
    Enum: "USER_ID", "REGISTRAR_USER_ID"

  - `userId.userId` (object, required)
    User identifier

  - `userId.userId.id` (string, required)

  - `paginationParams` (object)
    Pagination request for token-based pagination, where a token is used to retrieve the next page of results.

  - `paginationParams.requestType` (string, required)
    Discriminator for the type of pagination.
    Enum: "PAGE_TOKEN", "PAGE_SIZE", "PAGE_INDEX"

  - `paginationParams.pageToken` (string, required)
    The page token.
    Example: token

  - `paginationParams.pageSize` (integer)
    The page size.
    Example: 10

  - `paginationParams.pageIndex` (integer, required)
    Page to fetch. The first page is 1.
    Example: 2

  - `paginationParams.searchKey` (string)
    Search key from the previous hotel search response.

  - `paginationParams.pageSize` (integer)
    Number of hotels to return.
    Example: 25

  - `corporateInfo` (object)
    Corporate data to be collected during the search request workflow.

  - `corporateInfo.preSearchAnswers` (object)

  - `corporateInfo.preSearchAnswers.answers` (array)

  - `corporateInfo.preSearchAnswers.answers.entityId` (string)
    The unique ID for the question.

  - `corporateInfo.preSearchAnswers.answers.userInput` (string)
    The text input given by user (if any).

  - `corporateInfo.preSearchAnswers.answers.itemIds` (array)
    The id/enum value corresponding to the option chosen by the user as
answer.

  - `corporateInfo.preSearchAnswers.answers.answers` (array)

  - `corporateInfo.preSearchAnswers.answers.answers.item` (string)
    The option selected from the list of available choices.

  - `corporateInfo.preSearchAnswers.answers.answers.value` (string)
    The additional input provided (by the user) while selecting one of the options.

  - `corporateInfo.preSearchAnswers.answers.answers.description` (string)
    Description of the selected option.

  - `corporateInfo.preSearchAnswers.answers.customFieldType` (string)
    The type of custom field.
    Enum: "QUESTION", "MEETING", "BUDGET", "BREX_TOKEN"

  - `corporateInfo.preSearchAnswers.answers.questionDisplayText` (string)
    The question text to be displayed to the user.

  - `corporateInfo.preSearchAnswers.answers.question` (object)
    The message defines the format of a question which can be asked to a user in any kind of workflows.

  - `corporateInfo.preSearchAnswers.answers.question.id` (string, required)

  - `corporateInfo.preSearchAnswers.answers.question.name` (string, required)
    Question display name that the user will see. For eg, 'Choose the purpose of your trip'.

  - `corporateInfo.preSearchAnswers.answers.question.questionFormat` (string)
    Question types. INPUT_BOX will make user enter a free flowing text.
RADIO_BUTTON will have multiple options, user can select only one.
CHECKBOX questions contain the possible set of options, from which the user can choose multiple options.
CHECKBOX_WITH_PERCENTAGE is similar to checkbox, with the difference being that each option having an additional input field whose values must add up to 100.
    Enum: "INPUT_BOX", "RADIO_BUTTON", "CHECKBOX", "CHECKBOX_WITH_PERCENTAGE"

  - `corporateInfo.preSearchAnswers.answers.question.optionInfo` (object)
    Options related information for the question.

  - `corporateInfo.preSearchAnswers.answers.question.optionInfo.source` (string, required)
    Option source
    Enum: "MANUAL", "COMPANY_CONFIG"

  - `corporateInfo.preSearchAnswers.answers.question.optionInfo.sourceMetadata` (object)
    Metadata information for the option source.

  - `corporateInfo.preSearchAnswers.answers.question.optionInfo.sourceMetadata.companyConfig` (object)
    For this option source, options would be auto generated based on specified parameter.

  - `corporateInfo.preSearchAnswers.answers.question.optionInfo.sourceMetadata.companyConfig.optionsParam` (string, required)
    Parameter to form options for the custom field.
    Enum: "COST_CENTER", "LEGAL_ENTITY", "OFFICE", "DEPARTMENT"

  - `corporateInfo.preSearchAnswers.answers.question.optionInfo.totalNumOptions` (integer)
    Total number of options

  - `corporateInfo.preSearchAnswers.answers.question.optionInfo.options` (array)
    Available options for the question. This will contain only max 10 options if only 
summary is requested.

  - `corporateInfo.preSearchAnswers.answers.question.optionInfo.options.displayCode` (string, required)
    The code which is sent in answer response.

  - `corporateInfo.preSearchAnswers.answers.question.optionInfo.options.displayValue` (string)
    The text to be displayed to the user beside this option.

  - `corporateInfo.preSearchAnswers.answers.question.isRequired` (boolean, required)
    Whether its compulsory to answer the question or not.
    Example: true

  - `corporateInfo.preSearchAnswers.answers.question.isDisabled` (boolean, required)
    Whether the question is disabled or not. If true, this should not be asked.
    Example: true

  - `corporateInfo.preSearchAnswers.answers.question.includeInItinerary` (boolean)
    Whether to include this question in the itinerary related emails.
    Example: true

  - `corporateInfo.preSearchAnswers.answers.question.customFieldLocations` (array)

  - `corporateInfo.preSearchAnswers.answers.question.matchConditions` (object)
    Conditions to select the custom field for given context.

  - `corporateInfo.preSearchAnswers.answers.question.matchConditions.travelerConditions` (object)
    Matching conditions for traveler.

  - `corporateInfo.preSearchAnswers.answers.question.matchConditions.travelerConditions.workerTypes` (array)
    Worker types. Users belonging to any of these would match.

  - `corporateInfo.preSearchAnswers.answers.question.matchConditions.travelerConditions.countries` (array)
    Countries.

  - `corporateInfo.preSearchAnswers.answers.question.matchConditions.travelerConditions.legalEntities` (array)
    Legal entities

  - `corporateInfo.preSearchAnswers.answers.question.matchConditions.travelerConditions.legalEntities.id` (string, required)
    Example: b93dc51f-12dd-46c7-b7d6-1cb12cd3f5b3

  - `corporateInfo.preSearchAnswers.answers.question.matchConditions.travelerConditions.legalEntities.name` (string)
    Example: Name

  - `corporateInfo.preSearchAnswers.answers.question.matchConditions.travelerConditions.departments` (array)
    Departments

  - `corporateInfo.preSearchAnswers.answers.question.matchConditions.travelerConditions.costCenters` (array)
    Cost centers

  - `corporateInfo.preSearchAnswers.answers.question.matchConditions.travelerConditions.offices` (array)
    Offices

  - `corporateInfo.preSearchAnswers.answers.question.matchConditions.travelTypes` (array)
    Travel types to match.

  - `corporateInfo.preSearchAnswers.answers.question.matchConditions.travelRegionTypes` (array)
    Travel region types to match.

  - `corporateInfo.preSearchAnswers.answers.question.matchConditions.tripUsageTypes` (array)
    Trip usage types to match. If empty, all trip usage types will be matched.

  - `corporateInfo.preSearchAnswers.answers.question.questionType` (object)
    Question type.

  - `corporateInfo.preSearchAnswers.answers.question.questionType.preSearchQuestionType` (string)
    Types of pre-search questions.
PURPOSE_OF_TRIP required to ask purpose of the trip user is going to. For example: meeting, training, interview.
    Enum: "UNKNOWN_SEARCH_QUESTION_TYPE", "PURPOSE_OF_TRIP"

  - `corporateInfo.preSearchAnswers.answers.question.questionType.preCheckoutQuestionType` (string)
    Types of pre-checkout questions.
USER_DEFINED_QUESTION the default question type for all pre checkout questions which have been created from UI.
OOP_REASON_CODE is kept separate so that existing OOP flow doesn't break.
    Enum: "UNKNOWN_CHECKOUT_QUESTION_TYPE", "USER_DEFINED_QUESTION", "OOP_REASON_CODE"

  - `corporateInfo.preSearchAnswers.userEntitiesResponseId` (string)

  - `corporateInfo.customFieldV3Responses` (array)
    Answers to the company's pre-search custom fields.

  - `corporateInfo.customFieldV3Responses.fieldId` (string, required)
    Custom field id

  - `corporateInfo.customFieldV3Responses.fieldName` (string)
    Name of the custom field

  - `corporateInfo.customFieldV3Responses.armId` (string, required)
    Arm id which is applicable

  - `corporateInfo.customFieldV3Responses.includeLocations` (array)

  - `corporateInfo.customFieldV3Responses.selectedOptions` (array, required)
    The list of options that are selected by user or auto populated.

  - `corporateInfo.customFieldV3Responses.selectedOptions.name` (string, required)
    Value of the selection

  - `corporateInfo.customFieldV3Responses.selectedOptions.translatedName` (string)
    Translated value of the selection

  - `corporateInfo.customFieldV3Responses.selectedOptions.description` (string)
    Description of the selection

  - `corporateInfo.customFieldV3Responses.selectedOptions.translatedDescription` (string)
    Translated description of the selection

  - `corporateInfo.customFieldV3Responses.selectedOptions.additionalUserInput` (string)
    Additional user input

  - `corporateInfo.customFieldV3Responses.selectedOptions.additionalInfos` (array)
    Actual values of the additional infos

  - `corporateInfo.customFieldV3Responses.selectedOptions.additionalInfoConfigs` (array)
    Additional info configs for the selected option

  - `corporateInfo.customFieldV3Responses.selectedOptions.additionalInfoConfigs.type` (string, required)
    Enum: "VARIABLE", "EXPRESSION"

  - `corporateInfo.customFieldV3Responses.selectedOptions.additionalInfoConfigs.name` (string, required)
    Name of the variable.
    Enum: "PUBLISHED_FARE", "LLF", "ADD_COLLECT_AMOUNT", "SELECTED_FARE", "SPLIT_PAYMENT_FARE"

  - `corporateInfo.customFieldV3Responses.selectedOptions.additionalInfoConfigs.formatExpression` (string, required)
    The expression must be of format : `<any_text> ${expression} <any_text>`.The expression
can consist of a combination of variables and mathematical operations.
Variable names must be same as VariableName Enum.
To define mathematical operations, the operation name should follow the format
`math.<math_op>(arg1, arg2)`. Both `arg1` and `arg2` can be variables or constants.
The supported math operations (math_op) include: `add, mul, div, sub, min, and max`. All keywords, such as `<math_op>, math, and var` must be written in lowercase.
    Example: Result:  ${math.mul(LLF,5)}  ${ADD_COLLECT_AMOUNT}

  - `corporateInfo.customFieldV3Responses.selectedOptions.additionalInfoConfigs.variables` (array)
    Reference names of the variables present in the expression.

  - `corporateInfo.customFieldV3Responses.selectedOptions.optionId` (string)
    Id of the selected option; sent by clients, never returned

  - `currencyCode` (string)
    Preferred currency for the search. Used when the price filter does not carry a currency.
    Example: USD

  - `sessionId` (string)
    Supplier session from the previous search response. Send it on later pages so progressive
search reuses the same supplier session.

  - `tripId` (string)
    Internal trip id when the search runs inside an existing trip.

  - `searchMetadata` (object)
    How the search was started. Sent when the traveler picked a hotel from autocomplete.

  - `searchMetadata.autocompleteSearchType` (string)
    Autocomplete entity the traveler selected.
    Enum: "UNKNOWN_TYPE", "AIRPORT", "HOTEL", "RAIL", "LOCATION", "OFFICE", "CITY_STATE_COUNTRY_CONTINENT", "CAR_VENDOR", "AIRLINE", "HOTEL_CHAIN", "CITY", "LIMO_VENDOR"

  - `searchMetadata.searchString` (string)
    Display name from the autocomplete selection.
    Example: The Savoy

## Response 200:

  - `200` (unknown)
    OK

## Response 200 fields (application/json):

  - `hotels` (array, required)
    List of hotels matching the search criteria.

  - `hotels.hotelDetailsKey` (string, required)
    Unique key for the hotel details.
    Example: Cg5TUE9UTkFOQTozMDc3NhIgCgIIARIMCgoyMDI0LTA=

  - `hotels.hotelSpec` (object, required)
    Includes detailed specifications for a hotel, such as name, star rating, address, coordinates, amenities, and other information.

  - `hotels.hotelSpec.name` (string, required)
    Name of the hotel.
    Example: London Heathrow Marriott Hotel

  - `hotels.hotelSpec.address` (object, required)
    Postal Address Details

  - `hotels.hotelSpec.address.addressLines` (array, required)
    Address lines

  - `hotels.hotelSpec.address.administrativeArea` (string)
    Code of administrative area. For example: DL for Delhi, India.
Highest administrative subdivision which is used for postal
addresses of a country or region.
For example, this can be a state, a province, an oblast, or a prefecture.
Specifically, for Spain this is the province and not the autonomous
community (e.g. "Barcelona" and not "Catalonia").
Many countries don't use an administrative area in postal addresses. E.g.
in Switzerland this should be left unpopulated.
    Example: CA

  - `hotels.hotelSpec.address.administrativeAreaName` (string)
    Name of administrative area. This is full name corresponding to administrativeArea. 
Like Delhi for DL area code. For some places, code and name maybe same as well like Tokyo.
    Example: California

  - `hotels.hotelSpec.address.description` (string)
    Address description
    Example: San Francisco Home

  - `hotels.hotelSpec.address.isDefault` (boolean)
    Whether this address is default address in case multiple addresses are specified.
    Example: true

  - `hotels.hotelSpec.address.languageCode` (string)
    BCP-47 language code of the contents of this address (if known). This is often the UI 
language of the input form or is expected to match one of the languages used in the 
address' country/region, or their transliterated equivalents.
This can affect formatting in certain countries, but is not critical to the correctness 
of the data and will never affect any validation or other non-formatting related operations.
Examples: "zh-Hant", "ja", "ja-Latn", "en".
    Example: en

  - `hotels.hotelSpec.address.locality` (string)
    Generally refers to the city/town portion of the address.
    Example: San Francisco

  - `hotels.hotelSpec.address.locationCode` (string)
    IATA 3-letter location code. See https://www.iata.org/en/services/codes.
    Example: LAX

  - `hotels.hotelSpec.address.organization` (string)
    The name of the organization at the address.
    Example: Spotnana

  - `hotels.hotelSpec.address.postalCode` (string)
    Postal code of the address. This is a required field when setting for a user/legal entity/company etc.
    Example: 94130

  - `hotels.hotelSpec.address.continentCode` (string)
    2 letter continent code of the continent this address falls in.
    Example: AF

  - `hotels.hotelSpec.address.recipients` (array)
    The recipient at the address.

  - `hotels.hotelSpec.address.regionCode` (string, required)
    Region code of the country/region of the address.
    Example: US

  - `hotels.hotelSpec.address.regionName` (string)
    Region name of the country/region of the address.
    Example: America

  - `hotels.hotelSpec.address.revision` (integer)
    Example: 1

  - `hotels.hotelSpec.address.sortingCode` (string)
    Additional, country-specific, sorting code. This is not used
in most regions. Where it is used, the value is either a string like
"CEDEX", optionally followed by a number (e.g. "CEDEX 7"), or just a number
alone, representing the "sector code" (Jamaica), "delivery area indicator"
(Malawi) or "post office indicator" (e.g. Côte d'Ivoire).
    Example: Jamaica

  - `hotels.hotelSpec.address.sublocality` (string)
    Sublocality of the address. This can be neighborhoods, boroughs, districts.

  - `hotels.hotelSpec.address.timezone` (string)
    Time zone of the address.
    Example: America/Los_Angeles

  - `hotels.hotelSpec.address.coordinates` (object)
    Latitude and Longitude for a Location

  - `hotels.hotelSpec.address.coordinates.latitude` (number, required)
    Latitude of the Location
    Example: 77.1025

  - `hotels.hotelSpec.address.coordinates.longitude` (number, required)
    Longitude of the Location
    Example: 28.7041

  - `hotels.hotelSpec.contactInfo` (object, required)
    Provides contact information for a hotel.

  - `hotels.hotelSpec.contactInfo.phone` (array, required)
    List of phone numbers for the hotel.

  - `hotels.hotelSpec.contactInfo.phone.countryCode` (integer)
    two digit country code
    Example: 91

  - `hotels.hotelSpec.contactInfo.phone.countryCodeSource` (string)
    Enum: "UNSPECIFIED", "FROM_NUMBER_WITH_PLUS_SIGN", "FROM_NUMBER_WITH_IDD", "FROM_NUMBER_WITHOUT_PLUS_SIGN", "FROM_DEFAULT_COUNTRY"

  - `hotels.hotelSpec.contactInfo.phone.extension` (string)
    phone number extension
    Example: 222

  - `hotels.hotelSpec.contactInfo.phone.isoCountryCode` (string)
    ISO alpha-2 code
    Example: IN

  - `hotels.hotelSpec.contactInfo.phone.italianLeadingZero` (boolean)
    Example: true

  - `hotels.hotelSpec.contactInfo.phone.nationalNumber` (integer)
    Example: 8150

  - `hotels.hotelSpec.contactInfo.phone.numberOfLeadingZeros` (integer)
    Example: 1

  - `hotels.hotelSpec.contactInfo.phone.preferredDomesticCarrierCode` (string)
    Example: 7

  - `hotels.hotelSpec.contactInfo.phone.rawInput` (string)
    Example: 77777

  - `hotels.hotelSpec.contactInfo.phone.type` (string)
    Enum: "UNKNOWN_TYPE", "MOBILE", "LANDLINE"

  - `hotels.hotelSpec.contactInfo.fax` (array)
    List of fax numbers for the hotel.

  - `hotels.hotelSpec.contactInfo.email` (array, required)
    List of email addresses for the hotel.

  - `hotels.hotelSpec.amenities` (array, required)
    List of hotel amenities.

  - `hotels.hotelSpec.amenities.hotelAmenityType` (string, required)
    Enum: "TWENTY_FOUR_HOUR_FRONT_DESK", "TWENTY_FOUR_HOUR_ROOM_SERVICE", "TWENTY_FOUR_HOUR_SECURITY", "ADJOINING_ROOMS", "AIR_CONDITIONING", "AIRLINE_DESK", "ATM_CASH_MACHINE", "BABY_SITTING", "BBQ_PICNIC_AREA", "BILINGUAL_STAFF", "BOOKSTORE", "BOUTIQUES_STORES", "BRAILED_ELEVATORS", "BUSINESS_LIBRARY", "CAR_RENTAL_DESK", "CASINO", "CHECK_CASHING_POLICY", "CHECK_IN_KIOSK", "COCKTAIL_LOUNGE", "COFFEE_SHOP", "COIN_OPERATED_LAUNDRY", "CONCIERGE_DESK", "CONCIERGE_FLOOR", "CONFERENCE_FACILITIES", "COURTYARD", "CURRENCY_EXCHANGE", "DESK_WITH_ELECTRICAL_OUTLET", "DOCTOR_ON_CALL", "DOOR_MAN", "DRIVING_RANGE", "DRUGSTORE_PHARMACY", "DUTY_FREE_SHOP", "ELEVATORS", "EXECUTIVE_FLOOR", "EXERCISE_GYM", "EXPRESS_CHECK_IN", "EXPRESS_CHECK_OUT", "FAMILY_PLAN", "FLORIST", "FOLIOS", "FREE_AIRPORT_SHUTTLE", "FREE_PARKING", "FREE_TRANSPORTATION", "GAME_ROOM", "GIFT_NEWS_STAND", "HAIRDRESSER_BARBER", "ACCESSIBLE_FACILITIES", "HEALTH_CLUB", "HEATED_POOL", "HOUSEKEEPING_DAILY", "HOUSEKEEPING_WEEKLY", "ICE_MACHINE", "INDOOR_PARKING", "INDOOR_POOL", "JACUZZI", "JOGGING_TRACK", "KENNELS", "LAUNDRY_VALET_SERVICE", "LIQUOR_STORE", "LIVE_ENTERTAINMENT", "MASSAGE_SERVICES", "NIGHTCLUB", "OFF_SITE_PARKING", "ON_SITE_PARKING", "OUTDOOR_PARKING", "OUTDOOR_POOL", "PACKAGE_PARCEL_SERVICES", "PARKING", "PHOTOCOPY_CENTER", "PLAYGROUND", "POOL", "POOLSIDE_SNACK_BAR", "PUBLIC_ADDRESS_SYSTEM", "RAMP_ACCESS", "RECREATIONAL_VEHICLE_PARKING", "RESTAURANT", "ROOM_SERVICE", "SAFE_DEPOSIT_BOX", "SAUNA", "SECURITY", "SHOE_SHINE_STAND", "SHOPPING_MALL", "SOLARIUM", "SPA", "SPORTS_BAR", "STEAM_BATH", "STORAGE_SPACE", "SUNDRY_CONVENIENCE_STORE", "TECHNICAL_CONCIERGE", "THEATRE_DESK", "TOUR_SIGHTSEEING_DESK", "TRANSLATION_SERVICES", "TRAVEL_AGENCY", "TRUCK_PARKING", "VALET_CLEANING", "DRY_CLEANING", "VALET_PARKING", "VENDING_MACHINES", "VIDEO_TAPES", "WAKEUP_SERVICE", "WHEELCHAIR_ACCESS", "WHIRLPOOL", "MULTILINGUAL_STAFF", "WEDDING_SERVICES", "BANQUET_FACILITIES", "BELL_STAFF_PORTER", "BEAUTY_SHOP_SALON", "COMPLIMENTARY_SELF_SERVICE_LAUNDRY", "DIRECT_DIAL_TELEPHONE", "FEMALE_TRAVELER_ROOM_FLOOR", "PHARMACY", "STABLES", "ONE_TWENTY_AC", "ONE_TWENTY_DC", "TWO_TWENTY_AC", "ACCESSIBLE_PARKING", "TWO_TWENTY_DC", "BARBEQUE_GRILLS", "WOMENS_CLOTHING", "MENS_CLOTHING", "CHILDRENS_CLOTHING", "SHOPS_AND_COMMERCIAL_SERVICES", "VIDEO_GAMES", "SPORTS_BAR_OPEN_FOR_LUNCH", "SPORTS_BAR_OPEN_FOR_DINNER", "ROOM_SERVICE_FULL_MENU", "ROOM_SERVICE_LIMITED_MENU", "ROOM_SERVICE_LIMITED_HOURS", "VALET_SAME_DAY_DRY_CLEANING", "BODY_SCRUB", "BODY_WRAP", "PUBLIC_AREA_AIR_CONDITIONED", "EFOLIO_AVAILABLE_TO_COMPANY", "INDIVIDUAL_EFOLIO_AVAILABLE", "VIDEO_REVIEW_BILLING", "BUTLER_SERVICE", "COMPLIMENTARY_IN_ROOM_COFFEE_OR_TEA", "COMPLIMENTARY_BUFFET_BREAKFAST", "COMPLIMENTARY_COCKTAILS", "COMPLIMENTARY_COFFEE_IN_LOBBY", "COMPLIMENTARY_CONTINENTAL_BREAKFAST", "COMPLIMENTARY_FULL_AMERICAN_BREAKFAST", "DINNER_DELIVERY_SERVICE_FROM_LOCAL_RESTAURANT", "COMPLIMENTARY_NEWSPAPER_DELIVERED_TO_ROOM", "COMPLIMENTARY_NEWSPAPER_IN_LOBBY", "COMPLIMENTARY_SHOESHINE", "EVENING_RECEPTION", "FRONT_DESK", "GROCERY_SHOPPING_SERVICE_AVAILABLE", "HALAL_FOOD_AVAILABLE", "KOSHER_FOOD_AVAILABLE", "LIMOUSINE_SERVICE", "MANAGERS_RECEPTION", "MEDICAL_FACILITIES_SERVICE", "TELEPHONE_JACK_ADAPTOR_AVAILABLE", "ALL_INCLUSIVE_MEAL_PLAN", "BUFFET_BREAKFAST", "COMMUNAL_BAR_AREA", "CONTINENTAL_BREAKFAST", "FULL_MEAL_PLAN", "FULL_AMERICAN_BREAKFAST", "MEAL_PLAN_AVAILABLE", "MODIFIED_AMERICAN_MEAL_PLAN", "FOOD_AND_BEVERAGE_OUTLETS", "LOUNGES_BARS", "BARBER_SHOP", "VIDEO_CHECKOUT", "ONSITE_LAUNDRY", "TWENTY_FOUR_HOUR_FOOD_AND_BEVERAGE_KIOSK", "CONCIERGE_LOUNGE", "PARKING_FEE_MANAGED_BY_HOTEL", "TRANSPORTATION", "BREAKFAST_SERVED_IN_RESTAURANT", "LUNCH_SERVED_IN_RESTAURANT", "DINNER_SERVED_IN_RESTAURANT", "FULL_SERVICE_HOUSEKEEPING", "LIMITED_SERVICE_HOUSEKEEPING", "HIGH_SPEED_INTERNET_ACCESS_FOR_LAPTOP_IN_PUBLIC_AREAS", "WIRELESS_INTERNET_CONNECTION_IN_PUBLIC_AREAS", "ADDITIONAL_SERVICES_AMENITIES_FACILITIES_ON_PROPERTY", "TRANSPORTATION_SERVICES_LOCAL_AREA", "TRANSPORTATION_SERVICES_LOCAL_OFFICE", "DVD_VIDEO_RENTAL", "PARKING_LOT", "PARKING_DECK", "STREET_SIDE_PARKING", "COCKTAIL_LOUNGE_WITH_ENTERTAINMENT", "COCKTAIL_LOUNGE_WITH_LIGHT_FARE", "MOTORCYCLE_PARKING", "PHONE_SERVICES", "BALLROOM", "BUS_PARKING", "CHILDRENS_PLAY_AREA", "CHILDRENS_NURSERY", "DISCO", "EARLY_CHECK_IN", "LOCKER_ROOM", "NON_SMOKING_ROOMS_GENERIC", "TRAIN_ACCESS", "AEROBICS_INSTRUCTION", "BAGGAGE_HOLD", "BICYCLE_RENTALS", "DIETICIAN", "LATE_CHECK_OUT_AVAILABLE", "PET_SITTING_SERVICES", "PRAYER_MATS", "SPORTS_TRAINER", "TURNDOWN_SERVICE", "DVDS_VIDEOS_CHILDREN", "BANK", "LOBBY_COFFEE_SERVICE", "BANKING_SERVICES", "STAIRWELLS", "PET_AMENITIES_AVAILABLE", "EXHIBITION_CONVENTION_FLOOR", "LONG_TERM_PARKING", "CHILDREN_NOT_ALLOWED", "CHILDREN_WELCOME", "COURTESY_CAR", "HOTEL_DOES_NOT_PROVIDE_PORNOGRAPHIC_FILMS_TV", "HOTSPOTS", "FREE_HIGH_SPEED_INTERNET_CONNECTION", "INTERNET_SERVICES", "PETS_ALLOWED", "GOURMET_HIGHLIGHTS", "CATERING_SERVICES", "COMPLIMENTARY_BREAKFAST", "BUSINESS_CENTER", "BUSINESS_SERVICES", "SECURED_PARKING", "RACQUETBALL", "SNOW_SPORTS", "TENNIS_COURT", "WATER_SPORTS", "CHILD_PROGRAMS", "GOLF", "HORSEBACK_RIDING", "OCEANFRONT", "BEACHFRONT", "HAIR_DRYER", "IRONING_BOARD", "HEATED_GUEST_ROOMS", "TOILET", "PARLOR", "VIDEO_GAME_PLAYER", "THALASSOTHERAPY", "PRIVATE_DINING_FOR_GROUPS", "HEARING_IMPAIRED_SERVICES", "CARRYOUT_BREAKFAST", "DELUXE_CONTINENTAL_BREAKFAST", "HOT_CONTINENTAL_BREAKFAST", "HOT_BREAKFAST", "PRIVATE_POOL", "CONNECTING_ROOMS", "DATA_PORT", "EXTERIOR_CORRIDORS", "GULF_VIEW", "ACCESSIBLE_ROOMS", "HIGH_SPEED_INTERNET_ACCESS", "INTERIOR_CORRIDORS", "HIGH_SPEED_WIRELESS", "KITCHENETTE", "PRIVATE_BATH_OR_SHOWER", "FIRE_SAFETY_COMPLIANT", "WELCOME_DRINK", "BOARDING_PASS_PRINT_OUT_AVAILABLE", "PRINTING_SERVICES_AVAILABLE", "ALL_PUBLIC_AREAS_NON_SMOKING", "MEETING_ROOMS", "MOVIES_IN_ROOM", "SECRETARIAL_SERVICE", "SNOW_SKIING", "WATER_SKIING", "FAX_SERVICE", "GREAT_ROOM", "LOBBY", "MULTIPLE_PHONE_LINES_BILLED_SEPARATELY", "UMBRELLAS", "GAS_STATION", "GROCERY_STORE", "TWENTY_FOUR_HOUR_COFFEE_SHOP", "AIRPORT_SHUTTLE_SERVICE", "LUGGAGE_SERVICE", "PIANO_BAR", "VIP_SECURITY", "COMPLIMENTARY_WIRELESS_INTERNET", "CONCIERGE_BREAKFAST", "SAME_GENDER_FLOOR", "CHILDREN_PROGRAMS", "BUILDING_MEETS_LOCAL_STATE_AND_COUNTRY_BUILDING_CODES", "INTERNET_BROWSER_ON_TV", "NEWSPAPER", "PARKING_CONTROLLED_ACCESS_GATES_TO_ENTER_PARKING_AREA", "HOTEL_SAFE_DEPOSIT_BOX_NOT_ROOM_SAFE_BOX", "STORAGE_SPACE_AVAILABLE_FEE", "TYPE_OF_ENTRANCES_TO_GUEST_ROOMS", "BEVERAGE_COCKTAIL", "CELL_PHONE_RENTAL", "COFFEE_TEA", "EARLY_CHECK_IN_GUARANTEE", "FOOD_AND_BEVERAGE_DISCOUNT", "LATE_CHECK_OUT_GUARANTEE", "ROOM_UPGRADE_CONFIRMED", "ROOM_UPGRADE_ON_AVAILABILITY", "SHUTTLE_TO_LOCAL_BUSINESSES", "SHUTTLE_TO_LOCAL_ATTRACTIONS", "SOCIAL_HOUR", "VIDEO_BILLING", "WELCOME_GIFT", "HYPOALLERGENIC_ROOMS", "ROOM_AIR_FILTRATION", "SMOKE_FREE_PROPERTY", "WATER_PURIFICATION_SYSTEM_IN_USE", "POOLSIDE_SERVICE", "CLOTHING_STORE", "ELECTRIC_CAR_CHARGING_STATIONS", "OFFICE_RENTAL", "PIANO", "INCOMING_FAX", "OUTGOING_FAX", "SEMI_PRIVATE_SPACE", "LOADING_DOCK", "BABY_KIT", "CHILDRENS_BREAKFAST", "CLOAKROOM_SERVICE", "COFFEE_LOUNGE", "EVENTS_TICKET_SERVICE", "LATE_CHECK_IN", "LIMITED_PARKING", "OUTDOOR_SUMMER_BAR_CAFE", "NO_PARKING_AVAILABLE", "BEER_GARDEN", "GARDEN_LOUNGE_BAR", "SUMMER_TERRACE", "WINTER_TERRACE", "ROOF_TERRACE", "BEACH_BAR", "HELICOPTER_SERVICE", "FERRY", "TAPAS_BAR", "CAFE_BAR", "SNACK_BAR", "GUESTROOM_WIRED_INTERNET", "GUESTROOM_WIRELESS_INTERNET", "FITNESS_CENTER", "ALCOHOLIC_BEVERAGES", "NON_ALCOHOLIC_BEVERAGES", "HEALTH_AND_BEAUTY_SERVICES", "LOCAL_CALLS", "MINIBAR", "REFRIGERATOR", "IN_ROOM_SAFE", "SMOKING_ROOMS_AVAILBLE", "MOUNTAIN_VIEW", "POOL_VIEW", "BEACH_VIEW", "OCEAN_VIEW", "ROOMS_WITH_BALCONY", "FAMILY_ROOM", "CRIB_CHARGE", "ROLLAWAY_ADULT", "FREE_WIFI_IN_MEETING_ROOMS", "ECO_FRIENDLY", "EXTRA_PERSON", "STAY_SAFE", "ENHANCED_HYGIENE_CLEANLINESS_PROTOCOLS"

  - `hotels.hotelSpec.amenities.additionalInfo` (string)
    Amenity description
    Example: Complimentary in-room coffee or tea

  - `hotels.hotelSpec.amenities.isComplimentary` (boolean)
    Is Amenity complimentary
    Example: true

  - `hotels.hotelSpec.descriptions` (array)
    List of hotel descriptions.

  - `hotels.hotelSpec.descriptions.type` (string)
    Hotel description type
    Enum: "GENERAL", "ALERTS", "DINING", "FACILITIES", "RECREATION", "SERVICES", "ATTRACTIONS", "CANCELLATION_POLICY", "DEPOSIT_POLICY", "DIRECTIONS", "POLICIES", "SAFETY", "TRANSPORTATION"

  - `hotels.hotelSpec.descriptions.value` (string)
    Hotel description value

  - `hotels.hotelSpec.imageSets` (array)
    List of hotel image sets.

  - `hotels.hotelSpec.imageSets.category` (string, required)
    Category of image such as exterior, spa, etc.
    Enum: "UNKNOWN_CATEGORY", "EXTERIOR_VIEW", "LOBBY_VIEW", "POOL_VIEW", "RESTAURANT", "HEALTH_CLUB", "GUEST_ROOM", "SUITE", "MEETING_ROOM", "BALLROOM", "GOLF_COURSE", "BEACH", "SPA", "BAR_OR_LOUNGE", "RECREATIONAL_FACILITY", "LOGO", "BASICS", "MAP", "PROMOTIONAL", "HOT_NEWS", "MISCELLANEOUS", "GUEST_ROOM_AMENITY", "PROPERTY_AMENITY", "BUSINESS_CENTER"

  - `hotels.hotelSpec.imageSets.imageGroup` (object, required)
    Contains different sizes of the same image.

  - `hotels.hotelSpec.imageSets.imageGroup.caption` (string)
    Caption for the image.
    Example: Exterior

  - `hotels.hotelSpec.imageSets.imageGroup.images` (array, required)
    List of images.

  - `hotels.hotelSpec.imageSets.imageGroup.images.data` (string)
    Example: 6935813e12584abda0e43d71cd2ea260

  - `hotels.hotelSpec.imageSets.imageGroup.images.dimensions` (object)
    Image dimensions ie width and height.

  - `hotels.hotelSpec.imageSets.imageGroup.images.dimensions.height` (integer)
    Example: 120

  - `hotels.hotelSpec.imageSets.imageGroup.images.dimensions.width` (integer)
    Example: 240

  - `hotels.hotelSpec.imageSets.imageGroup.images.url` (string)
    Example: https://static.wixstatic.com/media/73f2e2_6935813e12584abda0e43d71cd2ea260~mv2.png/v1/fill/w_630,h_94,al_c,q_85,usm_0.66_1.00_0.01/Spotnana%403x.webp

  - `hotels.hotelSpec.imageSets.imageGroup.images.metadata` (object)
    Metadata associated with an image.

  - `hotels.hotelSpec.imageSets.imageGroup.images.metadata.variant` (string)
    Image variant.
    Enum: "LIGHT", "DARK"

  - `hotels.hotelSpec.hotelId` (string, required)
    Unique hotel identifier.
    Example: SPOTNANA:1001

  - `hotels.hotelSpec.brandCode` (string)
    The code of hotel brand.
    Example: MC

  - `hotels.hotelSpec.brandName` (string)
    Brand name of the hotel.
    Example: Marriott Hotel Brands

  - `hotels.hotelSpec.chainCode` (string)
    The code of hotel chain.
    Example: EM

  - `hotels.hotelSpec.chainName` (string)
    Name of the hotel chain.
    Example: Marriott Hotels & Resorts

  - `hotels.hotelSpec.propertyTypes` (array, required)
    List of property types for the hotel.

  - `hotels.hotelSpec.propertyTypes.type` (string, required)
    Enum: "ALL_SUITE", "ALL_INCLUSIVE_RESORT", "APARTMENT", "BED_AND_BREAKFAST", "CABIN_OR_BUNGALOW", "CAMPGROUND", "CHALET", "CONDOMINIUM", "CONFERENCE_CENTER", "CORPORATE_BUSINESS_TRANSIENT", "CRUISE", "EXTENDED_STAY", "GUEST_FARM", "GUEST_HOUSE_LIMITED_SERVICE", "HEALTH_SPA", "HOLIDAY_RESORT", "HOSTEL", "HOTEL", "INN", "LODGE", "MONASTERY", "MOTEL", "RANCH", "RESIDENTIAL_APARTMENT", "RESORT", "TENT", "VACATION_HOME", "VILLA", "WILDLIFE_RESERVE", "CASTLE", "GOLF", "PENSION", "SKI", "SPA", "BOATEL", "HISTORICAL", "RECREATIONAL_VEHICLE_PARK", "CHARM_HOTEL", "OTHER"

  - `hotels.hotelSpec.propertyTypes.description` (string)
    Description of the property type.

  - `hotels.hotelSpec.starRating` (object, required)
    Details about hotel star rating.

  - `hotels.hotelSpec.starRating.starRating` (number, required)
    Star rating of the hotel.
    Example: 3

  - `hotels.hotelSpec.starRating.ratingType` (string, required)
    Enum representing the type of star rating.
    Enum: "OFFICIAL", "SELF_RATED"

  - `hotels.hotelSpec.additionalAmenities` (array)
    Additional amenities provided by the hotel.

  - `hotels.hotelSpec.checkinTime` (object)
    ISO8601 Local Time

  - `hotels.hotelSpec.checkinTime.iso8601` (string, required)
    Example: 17:32

  - `hotels.hotelSpec.vpayInfo` (object)
    Whether a property accepts virtual pay, and how reliably. Absent when there is no virtual pay information for the property, which reads as not accepted.

  - `hotels.hotelSpec.vpayInfo.vpayAccepted` (boolean, required)
    True when the property is known to accept virtual pay.
    Example: true

  - `hotels.hotelSpec.vpayInfo.vpayScore` (integer)
    Reliability score, 1-10. Higher is more reliable. Never contradicts vpayAccepted, so 0 means accepted with no score available rather than not accepted.
    Example: 9

  - `hotels.distance` (object, required)
    Specifies the length or a distance.

  - `hotels.distance.length` (number, required)
    Distance from search point.
    Example: 150

  - `hotels.distance.unit` (string, required)
    Unit of measure being applied.
    Enum: "UNKNOWN_UNIT", "KM", "MILE", "CENTIMETER", "METER"

  - `hotels.policyInfo` (object)
    Includes detailed information about a policy, such as its unique identifier, type, name, rules, version, and approval type.

  - `hotels.policyInfo.id` (object, required)
    Identifier of an object

  - `hotels.policyInfo.id.id` (string, required)
    Example: b93dc51f-12dd-46c7-b7d6-1cb12cd3f5b3

  - `hotels.policyInfo.policyType` (string, required)
    Policy type.
    Enum: "DEFAULT", "GROUP", "INTERNAL"

  - `hotels.policyInfo.policyName` (string, required)
    Name of the policy.

  - `hotels.policyInfo.ruleResultInfos` (array)
    Information about the policy rules.

  - `hotels.policyInfo.ruleResultInfos.violationInfos` (array)

  - `hotels.policyInfo.ruleResultInfos.violationInfos.predicateString` (string)

  - `hotels.policyInfo.ruleResultInfos.violationInfos.predicate` (string)
    This contains the enum mentioning the policy rule which was violated.
    Enum: "UNKNOWN_PREDICATE_STRING", "MAX_FARE_PER_TRAVELLER_VIOLATION", "FARE_MORE_THAN_MINIMUM", "FARE_MORE_THAN_MEDIAN", "FARE_LESS_THAN_MEDIAN", "FARE_MORE_THAN_LLF", "MAX_FARE_PER_TRAVELLER_VIOLATION_INCLUDING_TAX", "MAX_FARE_PER_TRAVELLER_VIOLATION_EXCLUDING_TAX", "HOTEL_PAYMENT_OPTIONS_VIOLATION", "RAIL_BOOKING_WINDOW_GAP_VIOLATION", "RAIL_TRAVEL_CLASS_VIOLATION", "RAIL_TICKET_REFUNDABLE_VIOLATION", "RAIL_MAX_BOOKING_PRICE_VIOLATION_INCLUDING_TAX", "RAIL_MAX_BOOKING_PRICE_VIOLATION_EXCLUDING_TAX", "AIR_MAX_PRICE_MORE_THAN_LLF_VIOLATION_INCLUDING_TAX", "AIR_MAX_PRICE_MORE_THAN_LLF_VIOLATION_EXCLUDING_TAX", "HOTEL_RESTRICTED_KEYWORDS_VIOLATION", "RESTRICTED_LOCATION_VIOLATION", "FLIGHT_ADVANCE_BOOKING_WINDOW_DOMESTIC_VIOLATION", "FLIGHT_ADVANCE_BOOKING_WINDOW_INTERNATIONAL_VIOLATION", "FLIGHT_ADVANCE_BOOKING_WINDOW_VIOLATION", "ITINERARY_WITHIN_EVENT_TRAVEL_WINDOW", "HOTEL_IN_ALLOWED_HOTEL_LIST", "PAYMENT_ACCESS_VIOLATION", "AIRPORT_IN_ALLOWED_AIRPORT_LIST", "ITINERARY_TYPE_IS_NOT_IN_ALLOWED_BOOKING_TYPES", "PAYMENT_AIR_ADDON_VIOLATION", "MAX_HOTEL_BOOKING_PRICE_INCLUDING_TAX", "MAX_HOTEL_BOOKING_PRICE_EXCLUDING_TAX", "AIR_NUM_TRAVELERS_ALLOWED", "PREFERRED_VENDOR_VIOLATION", "SEAT_ADDON_VIOLATION", "BAGGAGE_ADDON_VIOLATION", "EARLY_BIRD_ADDON_VIOLATION", "WIFI_ADDON_VIOLATION", "RESTRICTED_BOOKING_VIOLATION", "HIGHEST_ALLOWED_CABIN_VIOLATION", "LOWEST_FARE_PER_HOTEL_PROPERTY_VIOLATION", "AIR_RESTRICTED_FARES_VIOLATION", "AIR_ANCILLARY_VIOLATION"

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue` (object)

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.displaySuffix` (string)
    Optional display suffix for the policy const value

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.i` (integer)

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.l` (integer)

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.s` (string)

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.d` (number)

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.b` (boolean)

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.iList` (array)

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.dList` (array)

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.sList` (array)

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.money` (object)
    Money object containing details such as the amount, the currency code, and the converted amount.

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.money.amount` (number, required)
    The numeric value for the amount of money.
    Example: 510

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.money.currencyCode` (string, required)
    The 3-letter currency code for the money amount (defined using ISO 4217 standard).
    Example: GBP

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.money.convertedAmount` (number)
    The converted currency and amount that has been converted (if a currency conversion has been requested).
For example, if the call requests that money be sent in a specified currency (because the frontend requested
the backend to send money in the user's preferred currency).
    Example: 715.42

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.money.convertedCurrency` (string)
    The 3-letter currency code for the converted currency (defined using ISO 4217 standard).
    Example: USD

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.money.otherCoinage` (array)
    List of the dollar amount in other coinage systems like reward points, cryptocurrency etc.

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.userOrgId` (object)
    User and user's organization information.

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.userOrgId.organizationAgencyId` (object)
    Agency id for the organization.

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.userOrgId.organizationId` (object, required)
    Organization id for traveler.

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.userOrgId.userId` (object, required)
    User identifier

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.userOrgId.tmcInfo` (object)
    TMC config information.

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.userOrgId.tmcBasicInfo` (object)
    TMC related basic information.

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.legalEntityId` (object)
    The ID of the legal entity.

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.legalEntityId.id` (string, required)
    Example: fc1ccbce-8413-4fe9-b233-a324dfbe7421

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.officeId` (object)
    The unique ID of the office.

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.officeId.id` (string, required)
    The value of the unique ID for the office.
    Example: 531ccbce-8413-4fe9-b233-a324dfbe7421

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.userOrgIdList` (array)

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.legalEntityIdList` (array)

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.officeIdList` (array)
    A list of office IDs.

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.rating` (number)

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.percentage` (number)

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.iRange` (object)

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.iRange.min` (integer)
    Minimum value - inclusive.

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.iRange.max` (integer)
    Maximum value - inclusive.

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.dRange` (object)

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.dRange.min` (number)
    Minimum value - inclusive.

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.dRange.max` (number)
    Maximum value - inclusive.

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.persona` (string)
    Persona of the user
    Enum: "UNKNOWN_PERSONA", "EMPLOYEE", "GUEST", "PERSONAL", "RELATIVE", "ADHOC"

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.personaList` (array)

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.railTravelClass` (string)
    Rail Travel classes in hierarchy numbering higher to keep scope for future additions in 
between.
    Enum: "UNKNOWN", "STANDARD", "COACH", "STANDARD_PREMIUM", "BUSINESS", "BUSINESS_PREMIUM", "FIRST", "SLEEPER"

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.keywordWithReasonList` (object)

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.keywordWithReasonList.keywords` (array)

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.workerType` (string)
    The type of worker.
    Enum: "EMPLOYEE", "CONTINGENT", "SEASONAL", "INTERN", "GUEST"

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.workerTypeList` (array)

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.airRestrictedFaresParams` (object)

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.airRestrictedFaresParams.airRestrictedKeywords` (array)
    List of keywords grouped by airline

  - `hotels.policyInfo.ruleResultInfos.violationInfos.expectedValue.postalAddressList` (array)

  - `hotels.policyInfo.ruleResultInfos.subViolationInfos` (array)
    In case of complex rules this will contain extra information as to how the rule was 
calculated.

  - `hotels.policyInfo.ruleResultInfos.actions` (array)
    Followed actions if rule was satisfied else violated actions.

  - `hotels.policyInfo.ruleResultInfos.actions.flag` (object)

  - `hotels.policyInfo.ruleResultInfos.actions.flag.message` (string)

  - `hotels.policyInfo.ruleResultInfos.actions.hide` (boolean)

  - `hotels.policyInfo.ruleResultInfos.actions.alertOnSelection` (object)

  - `hotels.policyInfo.ruleResultInfos.actions.alertOnSelection.message` (string)

  - `hotels.policyInfo.ruleResultInfos.actions.takeApproval` (object)

  - `hotels.policyInfo.ruleResultInfos.actions.takeApproval.numHierarchyLevels` (integer)
    How many levels of hierarchy should approval be taken? If it's just immediate manager, 
this value would be 1. If it's manager and their manager, this would ge 2 and so on.

  - `hotels.policyInfo.ruleResultInfos.actions.takeApproval.positionTitles` (array)
    What position in the cost center or department. For eg, any business class upgrade 
might require VP approval.

  - `hotels.policyInfo.ruleResultInfos.actions.takeApproval.userOrgIds` (array)
    The specific users from whom to take approval. For eg, say for a company, all approvals
go through Adam.

  - `hotels.policyInfo.ruleResultInfos.actions.takeApproval.allRequired` (boolean)
    This tells whether all the people above needs to approve or if any of these approve, 
it is sufficient.

  - `hotels.policyInfo.ruleResultInfos.actions.takeApproval.hardApprovalRequired` (boolean)
    Whether to take soft approval (false) or hard approval (true).

  - `hotels.policyInfo.ruleResultInfos.actions.takeApproval.approvalType` (string)
    Type of APPROVAL
    Enum: "HARD_APPROVAL", "SOFT_APPROVAL", "PASSIVE_APPROVAL", "PRE_APPROVAL"

  - `hotels.policyInfo.ruleResultInfos.actions.preventBooking` (object)
    Whether to allow booking if a rule is violated.

  - `hotels.policyInfo.ruleResultInfos.actions.preventBooking.prevent` (boolean)
    True if booking is to be blocked if rule is violated, else false

  - `hotels.policyInfo.ruleResultInfos.actions.preventBooking.reason` (string)
    Reason describing why was that specific itinerary not allowed to book.

  - `hotels.policyInfo.ruleResultInfos.actions.splitPayment` (object)
    Split payment details for claiming reimbursements.

  - `hotels.policyInfo.ruleResultInfos.actions.splitPayment.isAmountReimbursable` (boolean)
    If the in policy amount is reimbursable or not.

  - `hotels.policyInfo.version` (integer, required)
    Version of the policy.

  - `hotels.hasNegotiatedRates` (boolean, required)
    Indicates if the hotel has negotiated rates.
    Example: false

  - `hotels.preferences` (array)
    List of preferences applicable to the hotel.

  - `hotels.preferences.preferredType` (string, required)
    Preference type.
    Enum: "NOT_PREFERRED", "COMPANY_PREFERRED", "SPOTTERS_CHOICE", "COMPANY_BLOCKED", "TMC_PREFERRED"

  - `hotels.preferences.blockedReason` (string)
    Reason for blocking the leg, hotel or car.

  - `hotels.preferences.label` (string)
    The label assigned to a specific tier of preference.

  - `hotels.rateInfo` (object, required)
    Contains detailed rate information for a hotel search.

  - `hotels.rateInfo.averageNightlyRate` (object, required)
    Rate details for hotel room

  - `hotels.rateInfo.averageNightlyRate.roomFees` (array)

  - `hotels.rateInfo.averageNightlyRate.roomFees.text` (string)
    Custom fee title. When absent, clients use the fee type as the label.
    Example: Resort fee

  - `hotels.rateInfo.averageNightlyRate.roomFees.feeInclusions` (array)
    Amenities included as part of the fee

  - `hotels.rateInfo.averageNightlyRate.roomFees.displayFee` (boolean)
    Flag to determine whether to explicitly show this fee type on UI

  - `hotels.rateInfo.averageNightlyRate.roomFees.feeType` (string)
    Fees Type
    Enum: "UNKNOWN", "BED_TAX", "CITY_HOTEL_FEE", "CITY_TAX", "COUNTRY_TAX", "ENERGY_TAX", "FEDERAL_TAX", "FOOD_AND_BEVERAGE_TAX", "LODGING_TAX", "MAINTENANCE_FEE", "OCCUPANCY_TAX", "PACKAGE_FEE", "RESORT_FEE", "SALES_TAX", "SERVICE_CHARGE", "STATE_TAX", "SURCHARGE", "TOTAL_TAX", "TOURISM_TAX", "VAT_GST_TAX", "SURPLUS_LINES_TAX", "INSURANCE_PREMIUM_TAX", "APPLICATON_FEE", "EXPRESS_HANDLING_FEE", "EXEMPT", "STANDARD", "ZERO_RATED", "MISCELLANEOUS", "ROOM_TAX", "EARLY_CHECKOUT_FEE", "COUNTRY_TAXES", "EXTRA_PERSON_CHARGE", "BANQUET_SERVICE_FEE", "ROOM_SERVICE_FEE", "LOCAL_FEE", "GOODS_AND_SERVICES_TAX", "VALUE_ADDED_TAX", "CRIB_FEE", "ROLLAWAY_FEE", "ASSESSMENT_LICENSE_TAX", "PET_SANITATION_FEE", "NOT_KNOWN", "CHILD_ROLLAWAY_CHARGE", "CONVENTION_TAX", "EXTRA_CHILD_CHARGE", "STANDARD_FOOD_AND_BEVERAGE_GRATUITY", "NATIONAL_GOVERNMENT_TAX", "ADULT_ROLLAWAY_FEE", "BEVERAGE_WITH_ALCOHOL", "BEVERAGE_WITHOUT_ALCOHOL", "TOBACCO", "FOOD", "TOTAL_SURCHARGES", "STATE_COST_RECOVERY_FEE", "MISCELLANEOUS_FEE", "DESTINATION_AMENITY_FEE", "REFUNDABLE_PET_FEE", "CHARITY_SUPPORT_FEE", "LOCAL_AMENITY_USAGE_MAINTENANCE_FEE", "CONVENTION_TOURISM_FEE", "DESTINATION_MARKETING_FEE", "HOTEL_DEVELOPMENT_FEE", "EVENT_FEE", "SUSTAINABILITY_FEE", "TRANSPORTATION_TRANSFER_FEE", "INSURANCE_FEE", "LOCAL_GOVERNMENT_FEE", "LOCAL_ORDINANCE_SURCHARGE", "GUARANTEED_EARLY_CHECK_IN_FEE", "GUARANTEED_LATE_CHECK_OUT_FEE", "MODIFICATION_FEE", "HOTEL_ANCILLARY_EARLY_CHECK_IN_FEE", "HOTEL_ANCILLARY_LATE_CHECK_OUT_FEE", "HOTEL_ANCILLARY_PET_FEE", "HOTEL_ANCILLARY_WIFI_FEE", "HOTEL_ANCILLARY_BREAKFAST_FEE", "HOTEL_ANCILLARY_PARKING_FEE", "HOTEL_ANCILLARY_MEAL_PLAN_FEE", "ACCESSIBILITY_EQUIPMENT_FEE", "TOURISM_MARKETING_FEE"

  - `hotels.rateInfo.averageNightlyRate.commission` (object)
    Commision on rate

  - `hotels.rateInfo.averageNightlyRate.commission.commissionPercent` (number)
    Commission percentage
    Example: 7.5

  - `hotels.rateInfo.averageNightlyRate.taxBreakdown` (array)

  - `hotels.rateInfo.averageNightlyRate.taxBreakdown.taxCode` (string)
    Tax code
    Example: VAT

  - `hotels.rateInfo.averageNightlyRate.taxBreakdown.percentage` (number)
    Tax amount to total amount
    Example: 9

  - `hotels.rateInfo.averageNightlyRate.taxBreakdown.description` (string)
    Tax name or Tax Description
    Example: AIR TRAVELLERS SECURITY CHARGE

  - `hotels.rateInfo.averageNightlyRate.includesCommission` (boolean)
    Whether the rate includes commission
    Example: false

  - `hotels.rateInfo.averageNightlyRate.allowedFop` (array)
    Forms of payment allowed for this rate. Includes BREX_POINTS when the rate can be paid
with Brex points.

  - `hotels.rateInfo.isRefundable` (boolean, required)
    Set to true if the hotel rate type is refundable over the life of the
rate. This is not a statement about cancelling right now: a rate whose
free cancellation window has already closed still reports true here.
Use `currentlyRefundable` to decide whether cancelling today is free.
    Example: true

  - `hotels.rateInfo.currentlyRefundable` (string)
    Refundable status that is currently applicable in the hotel timezone,
evaluated against the cancellation deadlines of the rate this search
result is priced from. FALSE even if the rate is partially refundable.
UNKNOWN means the supplier does not expose cancellation deadlines at
search time, so no claim can be made without calling hotel details.
    Enum: "UNKNOWN", "TRUE", "FALSE"

  - `hotels.rateInfo.rewardPointsEarned` (array)
    Information about reward points earned.

  - `hotels.rateInfo.rewardPointsEarned.rewardPointsType` (string, required)
    Type of reward points.
    Enum: "QBR", "QFF"

  - `hotels.rateInfo.rewardPointsEarned.totalPointsEarned` (number, required)
    Total points that will be credited.

  - `hotels.rateInfo.rewardPointsEarned.conversionMultiplier` (number, required)
    Multiplier for converting points.

  - `hotels.rateInfo.promotionalOffers` (array)
    List of promotional offers applied to the hotel rate.

  - `hotels.rateInfo.promotionalOffers.name` (string, required)
    Name of the promotional offer applied on this hotel rate.

  - `hotels.hotelCo2EmissionDetail` (object)
    The co2 emission detail for the hotel.

  - `hotels.hotelCo2EmissionDetail.co2EmissionValue` (number, required)
    CO2 emission value in kg per room for the entire stay.
    Example: 10.5

  - `hotels.hotelEvaluationMetrics` (object)
    Rank and organization booking history for a hotel in search results.

  - `hotels.hotelEvaluationMetrics.rank` (integer)
    Rank of the hotel.
    Example: 1

  - `hotels.hotelEvaluationMetrics.orgBookedCount` (integer)
    Times this hotel has been booked by the organization.
    Example: 12

  - `hotels.hotelEvaluationMetrics.rankingScore` (number)
    Hotel ranking score.
    Example: 0.82

  - `metadata` (object, required)
    Includes metadata for a hotel search.

  - `metadata.availableHotelChains` (array, required)
    A list of available hotel chains.

  - `metadata.availableHotelChains.chainCode` (string)
    The code of hotel chain.
    Example: EM

  - `metadata.availableHotelChains.chainName` (string)
    The name of hotel chain.
    Example: Mariott

  - `metadata.rateStatistics` (object)
    Contains statistical information about hotel search results.

  - `metadata.rateStatistics.median` (object, required)
    Details median rate information for a hotel.

  - `metadata.rateStatistics.sampleSize` (integer, required)
    Size of the sample set used to calculate the statistics.
    Example: 100

  - `metadata.rateStatistics.policyType` (string, required)
    Enumeration of policy types for rate statistics.
    Enum: "DEFAULT", "SET_BY_ADMIN"

  - `metadata.rateStatistics.statisticalMethod` (string)
    Statistical method used for the recommended hotel rate.
    Enum: "MEDIAN", "MEAN"

  - `metadata.rateStatistics.preferredHotelsOnly` (boolean)
    Whether mean and median were calculated using only preferred hotels.
    Example: true

  - `metadata.showOnlyBaseFare` (boolean, required)
    Indicates if only base fare should be shown.
    Example: false

  - `metadata.sessionId` (string)
    Unique session identifier for the search.

  - `paginationParams` (object, required)
    Pagination response for token based pagination. Contains the next page token(if next page is available) and pagination parameters.

  - `paginationParams.nextPageToken` (string)
    The next page token to retrieve the next page of results. If it is empty, it indicates that there are no more pages to retrieve.

  - `paginationParams.currentPageSize` (integer, required)
    The number of results in the current page.
    Example: 10

  - `paginationParams.currentPageIndex` (integer)
    Page number of this response. The first page is 1.
    Example: 1

  - `paginationParams.totalNumPages` (integer)
    Total number of pages for this search.
    Example: 7

  - `paginationParams.totalNumResults` (integer)
    Total number of hotels matching the search.
    Example: 581

  - `paginationParams.searchKey` (string)
    Key for a later PAGE_INDEX request. Send it with pageIndex to open a specific page.

  - `virtualPaymentAvailable` (boolean)
    Indicates whether a virtual card payment source is available to the traveler for the hotels in this search.
    Example: false

  - `virtualPaymentMandated` (boolean)
    Indicates whether virtual payment is mandated for the traveler.
    Example: false

## Response 401:

  - `401` (unknown)
    Unauthorized

## Response 401 fields (application/json):

  - `debugIdentifier` (string)
    Link to debug the error internally.

  - `errorMessages` (array)

  - `errorMessages.errorCode` (string)
    Error code to identify the specific errors.

  - `errorMessages.message` (string)
    Message containing details of error.

  - `errorMessages.errorParameters` (array)
    Error message parameters.

  - `errorMessages.errorParameters.name` (string)
    Parameter name

  - `errorMessages.errorParameters.value` (string)
    Parameter value

  - `errorMessages.errorDetail` (string)
    More details about the error.

## Response 403:

  - `403` (unknown)
    Forbidden

## Response 403 fields (application/json):

  - `debugIdentifier` (string)
    Link to debug the error internally.

  - `errorMessages` (array)

  - `errorMessages.errorCode` (string)
    Error code to identify the specific errors.

  - `errorMessages.message` (string)
    Message containing details of error.

  - `errorMessages.errorParameters` (array)
    Error message parameters.

  - `errorMessages.errorParameters.name` (string)
    Parameter name

  - `errorMessages.errorParameters.value` (string)
    Parameter value

  - `errorMessages.errorDetail` (string)
    More details about the error.

## Response 404:

  - `404` (unknown)
    The specified resource was not found.

## Response 404 fields (application/json):

  - `debugIdentifier` (string)
    Link to debug the error internally.

  - `errorMessages` (array)

  - `errorMessages.errorCode` (string)
    Error code to identify the specific errors.

  - `errorMessages.message` (string)
    Message containing details of error.

  - `errorMessages.errorParameters` (array)
    Error message parameters.

  - `errorMessages.errorParameters.name` (string)
    Parameter name

  - `errorMessages.errorParameters.value` (string)
    Parameter value

  - `errorMessages.errorDetail` (string)
    More details about the error.

